{% extends 'pagination/pagination_base.html' %}
{% load static %}
{% block extrahead %}
	<script type="text/javascript" src="{% static "datetimepicker/bootstrap-datetimepicker.js" %}"></script>
	<link rel="stylesheet" type="text/css" href="{% static "datetimepicker/bootstrap-datetimepicker.css" %}"/>
{% endblock %}
{% block title %}Reports{% endblock %}
{% block content %}
<h1 style="margin-bottom: 25px">Area Usage Report</h1>
<form id="date-form" method="POST">
	{% csrf_token %}
	<div class="control-label col-sm-2">
		<label for="start_time">Select from</label>
	</div>
	<div class="col-sm-3 col-md-3 col-lg-2">
		<input type="text" id="start_time" name="start_time" class="form-control text-center" placeholder="Choose a date" required>
	</div>
	<div class="control-label col-sm-1 col-sm-1 col-lg-1" style="text-align: center">
		<label for="end_time">to</label>
	</div>
	<div class="col-sm-3 col-md-3 col-lg-2">
		<input type="text" id="end_time" name="end_time" class="form-control text-center" placeholder="Choose a date" required>
	</div>
	<div class="col-md-3">
		<button id="date-search" type="submit" class="btn btn-success">Search</button>
	</div>
</form>

<div style="height: 5px; border-top: 1px dotted #eee"></div>
<div id="data_table" style="margin-top: 8%;margin-left: 1.8%">
	{% if start != '0' %}
		{% if context %}
		<p>Tool usage events from {{start}} to {{end}}</p>
		<a href="#" class="btn btn-info" id="export">Export</a>
		<table border="1" class="table table-bordered" style="margin-top: 3%" id="projectSpreadsheet">
		  <tbody>
		  <tr>
			  <th style="font-size:16px">Area</th>
			  <th style="font-size:16px">Time (hhh:mm:ss)</th>
		  </tr>
		  {% for key, value in context.items %}
			<tr>
				 <td style="border-bottom: 1px solid lightgray">{{key}}</td>
				 <td style="border-bottom: 1px solid lightgray">{{value}}</td>
			</tr>
		  {% endfor %}
		  </tbody>
		</table>
<!--		{% if context.has_other_pages %}-->
<!--	  	<ul class="pagination">-->
<!--		{% if context.has_previous %}-->
<!--		  <li><a href="?page={{ context.previous_page_number }}">&laquo;</a></li>-->
<!--		{% else %}-->
<!--		  <li class="disabled"><span>&laquo;</span></li>-->
<!--		{% endif %}-->
<!--		{% for i in context.paginator.page_range %}-->
<!--		  {% if context.number == i %}-->
<!--			<li class="active"><span>{{ i }} <span class="sr-only">(current)</span></span></li>-->
<!--		  {% else %}-->
<!--			<li><a href="?page={{ i }}">{{ i }}</a></li>-->
<!--		  {% endif %}-->
<!--		{% endfor %}-->
<!--		{% if context.has_next %}-->
<!--		  <li><a href="?page={{ context.next_page_number }}">&raquo;</a></li>-->
<!--		{% else %}-->
<!--		  <li class="disabled"><span>&raquo;</span></li>-->
<!--		{% endif %}-->
<!--		  </ul>-->
<!--		{% endif %}-->
		{% else %}
			No area records exist between your input time.
		{% endif %}
	{% endif %}
  </div>
<script>
	function on_load()
		{
			var timepicker_properties =
			{
				format: 'MM/DD/YYYY'
			};
			$('#start_time').datetimepicker(timepicker_properties);
			$('#end_time').datetimepicker(timepicker_properties);
		}
		$(on_load);

	$("#date-search").click(function() {
		$("#data-form").attr("action", "usage-events/");
	});

	$('body').append('<div style="" id="loadingDiv"><div class="loader">Loading...</div></div>');
	$(window).on('load', function(){
	  setTimeout(removeLoader, 0); //wait for page load PLUS two seconds.
	});
	function removeLoader() {
		$("#loadingDiv").fadeOut(500, function () {
			// fadeOut complete. Remove the loading div
			$("#loadingDiv").remove(); //makes page more lightweight
		});
	}
	function sortTableByColumn(tableHeader) {
	  // extract all the relevant details
	  let table = tableHeader.closest('table')
	  let index = tableHeader.cellIndex
	  let sortType = tableHeader.dataset.sortType
		console.log(sortType)
	  let sortDirection = tableHeader.dataset.sortDir || 'asc' // default sort to ascending

	  // sort the table rows
	  let items = Array.prototype.slice.call(table.rows);
	  let sortFunction = getSortFunction(sortType, index, sortDirection)
	  let sorted = items.sort(sortFunction)

	  // remove and re-add rows to table
	  for (let row of sorted) {
		let parent = row.parentNode
		let detatchedItem = parent.removeChild(row)
		parent.appendChild(row)
	  }

	  // reset heading values and styles
	  for (let header of tableHeader.parentNode.children) {
		header.classList.remove('currently-sorted')
		delete header.dataset.sortDir
	  }

	  // update this headers's values and styles
	  tableHeader.dataset.sortDir = sortDirection == 'asc' ? 'desc' : 'asc'
	  tableHeader.classList.add('currently-sorted')
	}

	function getSortFunction(sortType, index, sortDirection) {
	  let dir = sortDirection == 'asc' ? -1 : 1
	  switch (sortType) {
		case 'text': return stringRowComparer(index, dir);
		case 'numeric': return numericRowComparer(index, dir);
		default: return stringRowComparer(index, dir);
	  }
	}

	// asc = alphanumeric order - eg 0->9->a->z
	// desc = reverse alphanumeric order - eg z->a->9->0
	function stringRowComparer(index, direction) {
	  return (a, b) => -1 * direction * a.children[index].textContent.localeCompare(b.children[index].textContent)
	}

	// asc = higest to lowest - eg 999->0
	// desc = lowest to highest - eg 0->999
	function numericRowComparer(index, direction) {
	  return (a, b) => direction * (Number(a.children[index].textContent) - Number(b.children[index].textContent))
	}

	$(document).ready(function () {

		function exportTableToCSV($table, filename) {

			var $rows = $table.find('tr:has(td),tr:has(th)'),

				// Temporary delimiter characters unlikely to be typed by keyboard
				// This is to avoid accidentally splitting the actual contents
				tmpColDelim = String.fromCharCode(11), // vertical tab character
				tmpRowDelim = String.fromCharCode(0), // null character

				// actual delimiter characters for CSV format
				colDelim = '","',
				rowDelim = '"\r\n"',

				// Grab text from table into CSV formatted string
				csv = '"' + $rows.map(function (i, row) {
					var $row = $(row), $cols = $row.find('td,th');

					return $cols.map(function (j, col) {
						var $col = $(col), text = $col.text();

						return text.replace(/"/g, '""'); // escape double quotes

					}).get().join(tmpColDelim);

				}).get().join(tmpRowDelim)
					.split(tmpRowDelim).join(rowDelim)
					.split(tmpColDelim).join(colDelim) + '"',



				// Data URI
				csvData = 'data:application/csv;charset=utf-8,' + encodeURIComponent(csv);

				console.log(csv);

				if (window.navigator.msSaveBlob) { // IE 10+
					//alert('IE' + csv);
					window.navigator.msSaveOrOpenBlob(new Blob([csv], {type: "text/plain;charset=utf-8;"}), "csvname.csv")
				}
				else {
					$(this).attr({ 'download': filename, 'href': csvData, 'target': '_blank' });
				}
		}

		// This must be a hyperlink
		$("#export").on('click', function (event) {

			exportTableToCSV.apply(this, [$('#projectSpreadsheet'), 'AreaUsageReport.csv']);

			// IF CSV, don't do event.preventDefault() or return false
			// We actually need this to be a typical hyperlink
		});
	});
</script>
<style>
	.loader,
        .loader:after {
            border-radius: 50%;
            width: 10em;
            height: 10em;
        }
        .loader {
            margin: 60px auto;
            font-size: 10px;
            position: relative;
            text-indent: -9999em;
            border-top: 1.1em solid rgba(255, 255, 255, 0.2);
            border-right: 1.1em solid rgba(255, 255, 255, 0.2);
            border-bottom: 1.1em solid rgba(255, 255, 255, 0.2);
            border-left: 1.1em solid #ffffff;
            -webkit-transform: translateZ(0);
            -ms-transform: translateZ(0);
            transform: translateZ(0);
            -webkit-animation: load8 1.1s infinite linear;
            animation: load8 1.1s infinite linear;
        }
        @-webkit-keyframes load8 {
            0% {
                -webkit-transform: rotate(0deg);
                transform: rotate(0deg);
            }
            100% {
                -webkit-transform: rotate(360deg);
                transform: rotate(360deg);
            }
        }
        @keyframes load8 {
            0% {
                -webkit-transform: rotate(0deg);
                transform: rotate(0deg);
            }
            100% {
                -webkit-transform: rotate(360deg);
                transform: rotate(360deg);
            }
        }
        #loadingDiv {
            position:absolute;;
            top:0;
            left:0;
            width:100%;
            height:100%;
            background-color:#000;
			opacity: 0.5;
        }
		table {
		  border-collapse: collapse;
		  border-spacing: 0;
		  width: 100%;
		  border: 1px solid #ddd;
		}

		th, td {
		  text-align: left;
		  padding: 16px;
		}

		tr:nth-child(odd) {
		  background-color: #f2f2f2;
		}
</style>
{% endblock %}